com.google.gwt.resources.gss

## Class RecordingBidiFlipper

- java.lang.Object
- - com.google.gwt.thirdparty.common.css.compiler.ast.DefaultTreeVisitor
  - - com.google.gwt.resources.gss.RecordingBidiFlipper

All Implemented Interfaces:
  com.google.gwt.thirdparty.common.css.compiler.ast.AtRuleHandler, com.google.gwt.thirdparty.common.css.compiler.ast.CssCompilerPass, com.google.gwt.thirdparty.common.css.compiler.ast.CssTreeVisitor

    public class RecordingBidiFlipper
    extends com.google.gwt.thirdparty.common.css.compiler.ast.DefaultTreeVisitor
    implements com.google.gwt.thirdparty.common.css.compiler.ast.CssCompilerPass

Compiler pass that BiDi flips all the flippable nodes and records if nodes have been flipped.

### Constructor Summary

Constructors
Constructor and Description
`RecordingBidiFlipper(com.google.gwt.thirdparty.common.css.compiler.ast.MutatingVisitController visitController, boolean swapLtrRtlInUrl, boolean swapLeftRightInUrl, boolean shouldFlipConstantReferences)`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `enterDeclaration(com.google.gwt.thirdparty.common.css.compiler.ast.CssDeclarationNode declaration)`
`boolean` `nodeFlipped()` return true if at least one node was flipped, false otherwise.
`void` `runPass()`

### Methods inherited from class com.google.gwt.thirdparty.common.css.compiler.ast.DefaultTreeVisitor

`enterArgumentNode, enterAttributeSelector, enterBlock, enterClassSelector, enterCombinator, enterComponent, enterCompositeValueNode, enterCompositeValueNodeOperator, enterConditionalBlock, enterConditionalRule, enterDeclarationBlock, enterDefinition, enterFontFace, enterForLoop, enterFunctionNode, enterIdSelector, enterImportBlock, enterImportRule, enterKey, enterKeyBlock, enterKeyframeRuleset, enterKeyframesRule, enterMediaRule, enterMediaTypeListDelimiter, enterMixin, enterMixinDefinition, enterPageRule, enterPageSelector, enterPropertyValue, enterProvideNode, enterPseudoClass, enterPseudoElement, enterRequireNode, enterRuleset, enterSelector, enterSelectorBlock, enterTree, enterUnknownAtRule, enterValueNode, leaveArgumentNode, leaveAttributeSelector, leaveBlock, leaveClassSelector, leaveCombinator, leaveComponent, leaveCompositeValueNode, leaveCompositeValueNodeOperator, leaveConditionalBlock, leaveConditionalRule, leaveDeclaration, leaveDeclarationBlock, leaveDefinition, leaveFontFace, leaveForLoop, leaveFunctionNode, leaveIdSelector, leaveImportBlock, leaveImportRule, leaveKey, leaveKeyBlock, leaveKeyframeRuleset, leaveKeyframesRule, leaveMediaRule, leaveMediaTypeListDelimiter, leaveMixin, leaveMixinDefinition, leavePageRule, leavePageSelector, leavePropertyValue, leaveProvideNode, leavePseudoClass, leavePseudoElement, leaveRequireNode, leaveRuleset, leaveSelector, leaveSelectorBlock, leaveTree, leaveUnknownAtRule, leaveValueNode, visit`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### RecordingBidiFlipper

    public RecordingBidiFlipper(com.google.gwt.thirdparty.common.css.compiler.ast.MutatingVisitController visitController,
                                boolean swapLtrRtlInUrl,
                                boolean swapLeftRightInUrl,
                                boolean shouldFlipConstantReferences)

### Method Detail

#### enterDeclaration

    public boolean enterDeclaration(com.google.gwt.thirdparty.common.css.compiler.ast.CssDeclarationNode declaration)

Specified by:
  `enterDeclaration` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.CssTreeVisitor`
Overrides:
  `enterDeclaration` in class `com.google.gwt.thirdparty.common.css.compiler.ast.DefaultTreeVisitor`

#### nodeFlipped

    public boolean nodeFlipped()

return true if at least one node was flipped, false otherwise.

#### runPass

    public void runPass()

Specified by:
  `runPass` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.CssCompilerPass`